//------------------------------------------------------------------------------
#ifndef UDPMulticastSocketH
#define UDPMulticastSocketH
//------------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Classes.hpp>
#include <Controls.hpp>
#include <vcl.h>
#include <stdio.h>
#include <stdlib.h>
#include <winsock2.h>
#include <ws2tcpip.h>

#include "..\\FUtls.h"
//------------------------------------------------------------------------------
#define DEFAULT_MCASTADDR     "234.5.6.7"
#define DEFAULT_MCASTPORT      23456
#define DEFAULT_BUFSIZE        1024
#define WM_SOCKET      WM_USER + 1
#define TEXT_MAX_LENGTH         128
//------------------------------------------------------------------------------
class TUDPMulticastSocket
{
private:
        UINT            ReceiveBufferSize;
        PCHAR           ReceiveBuffer;

        SOCKET          Sock, SockM;
protected:
        INT __fastcall CreateSock();
        INT __fastcall PrepareDataReceive(HANDLE aWindowHandle);
public:
        __fastcall TUDPMulticastSocket(TComponent* Owner);
        __fastcall ~TUDPMulticastSocket();

        INT __fastcall Send(PCHAR aBuffer, INT aBufLength);

        AnsiString      Address;
        int             Port;
        bool            LoopBack;
        HWND            Handle;
        TWinControl*    Owner;
};
//------------------------------------------------------------------------------
#endif
